
/************************************************************************
 *
 * SR/Z3950 application software version 1.0, August 1993.
 *
 * (C) Software Kinetics Ltd.
 *
 * Software Kinetics Ltd. has granted a licence of this software to the
 * National Library of Canada.
 *
 * The National Library of Canada grants to the user a royalty-free
 * non-exclusive licence in perpetuity to use, modify, improve, reproduce
 * and sell the software.
 *
 * The software is provided to the user "as is" without warranty of any
 * kind. Neither Software Kinetics Ltd. nor the National Library of Canada
 * warrants, guarantees or makes any representations regarding the use,
 * or the results of use of the software in terms of accuracy, reliability,
 * or otherwise. The entire risk as to results and performance of the
 * software is assumed by the user. Neither Software Kinetics Ltd. nor the
 * National Library of Canada shall be liable for any direct, indirect,
 * consequential or incidental damages arising out of the use of the
 * software.
 *
 ************************************************************************/

/****************************************************************************
 * UNIT: IRC Terminate
 *
 * DESCRIPTION:
 *	This interface unit is used to terminate the communication 
 *	service layer in an orderly fashion.
 *
 * CONTENTS:
 *	IRC_Terminate
 *
 * NOTES:
 *	This is a stub file.
 *
 *
 * $Log:
 * Revision 1.1  1993/09/16  09:03:27  irorigin
 * Baseline for Release 1.0.
 *
/***************************************************************************/

#include <ir.h>
#include <ir_cs.h>
#include <ir_pli.h>

/****************************************************************************
 * FUNCTION: IRC_Terminate 
 *
 * PURPOSE:
 *
 * INPUT:
 *
 *	There is no input required to this function.
 *
 * OUTPUT:
 *	This function returns an IR_STATUS which returns a non-zero
 *	value on error. 
 *
 *
 * NOTES:
 *	This is a stub function.
 *
 ***************************************************************************/

IR_STATUS IRC_Terminate ()
{
	IR_ASSOC_ID	assocId;
	if (!CsCf_IsIRCInitialized())
	{
		return(IR_FAIL);
	}

	/* Delete all open connections */
	while ((assocId = CsCf_AssocGetFirst()) 
	    != (IR_ASSOC_ID)IR_UNKNOWN_ID_TYPE)
	{
		CS_LOG_PRINTV(IR_FILE, "Closing assoc %d\n", assocId);
		(void)CsCf_CloseSocket(assocId);
	}

	CsCf_BuffTerm();
	return IR_SUCCESS;
}

