
/************************************************************************
 *
 * SR/Z3950 application software version 1.0, August 1993.
 *
 * (C) Software Kinetics Ltd.
 *
 * Software Kinetics Ltd. has granted a licence of this software to the
 * National Library of Canada.
 *
 * The National Library of Canada grants to the user a royalty-free
 * non-exclusive licence in perpetuity to use, modify, improve, reproduce
 * and sell the software.
 *
 * The software is provided to the user "as is" without warranty of any
 * kind. Neither Software Kinetics Ltd. nor the National Library of Canada
 * warrants, guarantees or makes any representations regarding the use,
 * or the results of use of the software in terms of accuracy, reliability,
 * or otherwise. The entire risk as to results and performance of the
 * software is assumed by the user. Neither Software Kinetics Ltd. nor the
 * National Library of Canada shall be liable for any direct, indirect,
 * consequential or incidental damages arising out of the use of the
 * software.
 *
 * $Log:
 * Revision 1.1  1993/09/16  09:03:27  irorigin
 * Baseline for Release 1.0.
 *
 *
 ************************************************************************/

#include "asn_incl.h"
#include "apdu.h"

/*
 *    ir.c
 *
 *    "IR" ASN.1 module encode/decode/print/free C src.
 *
 *    This file was generated by snacc on Wed May  4 14:15:20 1994
 *
 *    UBC snacc written by Mike Sample
 *
 *    NOTE: This is a machine generated file - editing not recommended
 */

void
PrintRPNStructureSeq PARAMS((f, v, indent),
FILE* f _AND_
RPNStructureSeq* v _AND_
unsigned short int indent)
{
    if (v == NULL)
        return;

    fprintf(f,"{ -- SEQUENCE --\n");

    Indent(f, indent + stdIndentG);
    PrintRPNStructure(f, (v->rPNStructure), indent + stdIndentG);
    fprintf(f, ",\n");
    Indent(f, indent + stdIndentG);
    PrintRPNStructure(f, (v->rPNStructure1), indent + stdIndentG);
    fprintf(f, ",\n");
    Indent(f, indent + stdIndentG);
    PrintOperator(f, (v->operator), indent + stdIndentG);
    fprintf(f,"\n");
    Indent(f, indent);
    fprintf(f,"}");
}  /* PrintRPNStructureSeq */

void
FreeRPNStructureSeq PARAMS((v),
RPNStructureSeq* v)
{

    if (v == NULL)
        return;
    FreeRPNStructure((v->rPNStructure));
    Asn1Free((v->rPNStructure));

    FreeRPNStructure((v->rPNStructure1));
    Asn1Free((v->rPNStructure1));

    FreeOperator((v->operator));
    Asn1Free((v->operator));

}  /* FreeRPNStructureSeq */




AsnLen
BEncRPNStructureContent PARAMS((b, v),
BUF_TYPE b _AND_
RPNStructure* v)
{
    AsnLen totalLen = 0;
    AsnLen itemLen;
    AsnLen listLen;
    void* component;

    switch(v->choiceId)
    {
       case(RPNSTRUCTURE_OPERAND):
    BEncEocIfNec(b);
    itemLen = BEncOperandContent( b, (v->a.operand));
    itemLen += BEncConsLen( b, itemLen);
    itemLen += BEncTag1(b, CNTX, CONS, 0);

    totalLen += itemLen;

    break;

       case(RPNSTRUCTURE_RPNSTRUCTURESEQ):
    BEncEocIfNec(b);
    itemLen = BEncRPNStructureSeqContent( b, (v->a.rPNStructureSeq));
    itemLen += BEncConsLen( b, itemLen);
    itemLen += BEncTag1(b, CNTX, CONS, 1);

    totalLen += itemLen;

    break;

    }
    return (totalLen);

}  /* BEncRPNStructureContent */

void
BDecRPNStructureContent PARAMS((b, tagId0, elmtLen0, v, bytesDecoded, env),
BUF_TYPE b _AND_
AsnTag tagId0 _AND_
AsnLen elmtLen0 _AND_
RPNStructure* v _AND_
AsnLen* bytesDecoded _AND_
ENV_TYPE env)
{
    int seqDone = FALSE;
    AsnLen totalElmtsLen1 = 0;
    AsnLen elmtLen1;
    AsnTag tagId1;
    int mandatoryElmtCount1 = 0;
    AsnLen totalElmtsLen2 = 0;
    AsnLen elmtLen2;
    AsnTag tagId2;
    AsnLen totalElmtsLen3 = 0;
    AsnLen elmtLen3;
    AsnTag tagId3;


    switch(tagId0)
    {
       case(MAKE_TAG_ID( CNTX, CONS, 0)):
        (v->choiceId) = RPNSTRUCTURE_OPERAND;
    (v->a.operand) = (Operand*) Asn1Alloc(sizeof(Operand));
    CheckAsn1Alloc((v->a.operand), env);
    tagId1 = BDecTag(b, &totalElmtsLen1, env);
    elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
    BDecOperandContent( b, tagId1, elmtLen1, (v->a.operand), &totalElmtsLen1, env);
    if (elmtLen0 == INDEFINITE_LEN)
        BDecEoc(b, &totalElmtsLen1, env);
    break;

       case(MAKE_TAG_ID( CNTX, CONS, 1)):
        (v->choiceId) = RPNSTRUCTURE_RPNSTRUCTURESEQ;
    (v->a.rPNStructureSeq) = (RPNStructureSeq*) Asn1Alloc(sizeof(RPNStructureSeq));
    CheckAsn1Alloc((v->a.rPNStructureSeq), env);
    BDecRPNStructureSeqContent( b, tagId0, elmtLen0, (v->a.rPNStructureSeq), &totalElmtsLen1, env);
    break;

    default:
        Asn1Error("ERROR - unexpected tag in CHOICE\n");
        longjmp(env, -213);
        break;
    } /* end switch */
    (*bytesDecoded) += totalElmtsLen1;
}  /* BDecRPNStructureContent */

void
PrintRPNStructure PARAMS((f, v, indent),
FILE* f _AND_
RPNStructure* v _AND_
unsigned short int indent)
{
    switch(v->choiceId)
    {
      case(RPNSTRUCTURE_OPERAND):
          PrintOperand(f, (v->a.operand), indent + stdIndentG);
          break;

      case(RPNSTRUCTURE_RPNSTRUCTURESEQ):
          PrintRPNStructureSeq(f, (v->a.rPNStructureSeq), indent + stdIndentG);
          break;

    }
}  /* PrintRPNStructure */

void
FreeRPNStructure PARAMS((v),
RPNStructure* v)
{

    if (v == NULL)
        return;
    switch(v->choiceId)
    {
       case(RPNSTRUCTURE_OPERAND):
    FreeOperand((v->a.operand));
    Asn1Free((v->a.operand));

    break;

       case(RPNSTRUCTURE_RPNSTRUCTURESEQ):
    FreeRPNStructureSeq((v->a.rPNStructureSeq));
    Asn1Free((v->a.rPNStructureSeq));

    break;

    }
}  /* FreeRPNStructure */




AsnLen
BEncRPNQueryContent PARAMS((b, v),
BUF_TYPE b _AND_
RPNQuery* v)
{
    AsnLen totalLen = 0;
    AsnLen itemLen;
    AsnLen listLen;
    void* component;

    itemLen = BEncRPNStructureContent( b, (v->rPNStructure));

    totalLen += itemLen;

    itemLen = BEncAsnOidContent( b, (&v->attributeSetId));
    itemLen += BEncDefLen( b, itemLen);
    itemLen += BEncTag1(b, UNIV, PRIM, 6);

    totalLen += itemLen;

    return (totalLen);

}  /* BEncRPNQueryContent */

void
BDecRPNQueryContent PARAMS((b, tagId0, elmtLen0, v, bytesDecoded, env),
BUF_TYPE b _AND_
AsnTag tagId0 _AND_
AsnLen elmtLen0 _AND_
RPNQuery* v _AND_
AsnLen* bytesDecoded _AND_
ENV_TYPE env)
{
    int seqDone = FALSE;
    AsnLen totalElmtsLen1 = 0;
    AsnLen elmtLen1;
    AsnTag tagId1;
    int mandatoryElmtCount1 = 0;
    AsnLen totalElmtsLen2 = 0;
    AsnLen elmtLen2;
    AsnTag tagId2;


    tagId1 = BDecTag(b, &totalElmtsLen1, env);

    if ((( tagId1 == MAKE_TAG_ID( UNIV, PRIM, OID_TAG_CODE))))
    {
    elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
    BDecAsnOidContent( b, tagId1, elmtLen1, (&v->attributeSetId), &totalElmtsLen1, env);
    tagId1 = BDecTag(b, &totalElmtsLen1, env);
    }
    else
        longjmp(env, -214);


    if ((( tagId1 == MAKE_TAG_ID( CNTX, CONS, 0)) ||
    ( tagId1 == MAKE_TAG_ID( CNTX, CONS, 1))))
    {
        elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
    (v->rPNStructure) = (RPNStructure*) Asn1Alloc(sizeof(RPNStructure));
    CheckAsn1Alloc((v->rPNStructure), env);
    BDecRPNStructureContent( b, tagId1, elmtLen1, (v->rPNStructure), &totalElmtsLen1, env);
        seqDone = TRUE;
        if ( elmtLen0 == INDEFINITE_LEN )
            BDecEoc(b, &totalElmtsLen1, env);
        else if (totalElmtsLen1 != elmtLen0)
            longjmp(env, -215);
    }
    else
        longjmp(env, -216);


    if (!seqDone)
        longjmp(env, -217);

    (*bytesDecoded) += totalElmtsLen1;
}  /* BDecRPNQueryContent */

void
PrintRPNQuery PARAMS((f, v, indent),
FILE* f _AND_
RPNQuery* v _AND_
unsigned short int indent)
{
    if (v == NULL)
        return;

    fprintf(f,"{ -- SEQUENCE --\n");

    Indent(f, indent + stdIndentG);
    fprintf(f,"attributeSetId ");
    PrintAsnOid(f, (&v->attributeSetId), indent + stdIndentG);
    fprintf(f, ",\n");
    Indent(f, indent + stdIndentG);
    PrintRPNStructure(f, (v->rPNStructure), indent + stdIndentG);
    fprintf(f,"\n");
    Indent(f, indent);
    fprintf(f,"}");
}  /* PrintRPNQuery */

void
FreeRPNQuery PARAMS((v),
RPNQuery* v)
{

    if (v == NULL)
        return;
    FreeAsnOid((&v->attributeSetId));

    FreeRPNStructure((v->rPNStructure));
    Asn1Free((v->rPNStructure));

}  /* FreeRPNQuery */




AsnLen
BEncQueryContent PARAMS((b, v),
BUF_TYPE b _AND_
Query* v)
{
    AsnLen totalLen = 0;
    AsnLen itemLen;
    AsnLen listLen;
    void* component;

    switch(v->choiceId)
    {
       case(QUERY_TYPE_0):
    itemLen = BEncAsnOctsContent( b, (v->a.type_0));
    itemLen += BEncDefLen( b, itemLen);
    itemLen += BEncTag1(b, CNTX, PRIM, 0);

    totalLen += itemLen;

    break;

       case(QUERY_TYPE_1):
    BEncEocIfNec(b);
    itemLen = BEncRPNQueryContent( b, (v->a.type_1));
    itemLen += BEncConsLen( b, itemLen);
    itemLen += BEncTag1(b, CNTX, CONS, 1);

    totalLen += itemLen;

    break;

       case(QUERY_TYPE_2):
    BEncEocIfNec(b);
    itemLen = BEncAsnOctsContent( b, (v->a.type_2));
    itemLen += BEncDefLen( b, itemLen);
    itemLen += BEncTag1(b, UNIV, PRIM, 4);
    itemLen += BEncConsLen( b, itemLen);
    itemLen += BEncTag1(b, CNTX, CONS, 2);

    totalLen += itemLen;

    break;

       case(QUERY_TYPE_100):
    BEncEocIfNec(b);
    itemLen = BEncAsnOctsContent( b, (v->a.type_100));
    itemLen += BEncDefLen( b, itemLen);
    itemLen += BEncTag1(b, UNIV, PRIM, 4);
    itemLen += BEncConsLen( b, itemLen);
    itemLen += BEncTag2(b, CNTX, CONS, 100);

    totalLen += itemLen;

    break;

       case(QUERY_TYPE_101):
    itemLen = BEncAsnOctsContent( b, (v->a.type_101));
    itemLen += BEncDefLen( b, itemLen);
    itemLen += BEncTag2(b, CNTX, PRIM, 101);

    totalLen += itemLen;

    break;

    }
    return (totalLen);

}  /* BEncQueryContent */

void
BDecQueryContent PARAMS((b, tagId0, elmtLen0, v, bytesDecoded, env),
BUF_TYPE b _AND_
AsnTag tagId0 _AND_
AsnLen elmtLen0 _AND_
Query* v _AND_
AsnLen* bytesDecoded _AND_
ENV_TYPE env)
{
    int seqDone = FALSE;
    AsnLen totalElmtsLen1 = 0;
    AsnLen elmtLen1;
    AsnTag tagId1;
    int mandatoryElmtCount1 = 0;
    AsnLen totalElmtsLen2 = 0;
    AsnLen elmtLen2;
    AsnTag tagId2;


    switch(tagId0)
    {
       case(MAKE_TAG_ID( CNTX, PRIM, 0)):
       case(MAKE_TAG_ID( CNTX, CONS, 0)):
        (v->choiceId) = QUERY_TYPE_0;
    (v->a.type_0) = (AsnOcts*) Asn1Alloc(sizeof(AsnOcts));
    CheckAsn1Alloc((v->a.type_0), env);
    BDecAsnOctsContent( b, tagId0, elmtLen0, (v->a.type_0), &totalElmtsLen1, env);
    break;

       case(MAKE_TAG_ID( CNTX, CONS, 1)):
        (v->choiceId) = QUERY_TYPE_1;
    (v->a.type_1) = (RPNQuery*) Asn1Alloc(sizeof(RPNQuery));
    CheckAsn1Alloc((v->a.type_1), env);
    BDecRPNQueryContent( b, tagId0, elmtLen0, (v->a.type_1), &totalElmtsLen1, env);
    break;

       case(MAKE_TAG_ID( CNTX, CONS, 2)):
    tagId1 = BDecTag(b, &totalElmtsLen1, env);
if ((tagId1 != MAKE_TAG_ID( UNIV, PRIM, OCTETSTRING_TAG_CODE)) &&
   (tagId1 != MAKE_TAG_ID( UNIV, CONS, OCTETSTRING_TAG_CODE)))
    {
         Asn1Error("Unexpected Tag\n");
         longjmp(env, -218);
    }

    elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
        (v->choiceId) = QUERY_TYPE_2;
    (v->a.type_2) = (AsnOcts*) Asn1Alloc(sizeof(AsnOcts));
    CheckAsn1Alloc((v->a.type_2), env);
    BDecAsnOctsContent( b, tagId1, elmtLen1, (v->a.type_2), &totalElmtsLen1, env);
    if (elmtLen0 == INDEFINITE_LEN)
        BDecEoc(b, &totalElmtsLen1, env);
    break;

       case(MAKE_TAG_ID( CNTX, CONS, 100)):
    tagId1 = BDecTag(b, &totalElmtsLen1, env);
if ((tagId1 != MAKE_TAG_ID( UNIV, PRIM, OCTETSTRING_TAG_CODE)) &&
   (tagId1 != MAKE_TAG_ID( UNIV, CONS, OCTETSTRING_TAG_CODE)))
    {
         Asn1Error("Unexpected Tag\n");
         longjmp(env, -219);
    }

    elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
        (v->choiceId) = QUERY_TYPE_100;
    (v->a.type_100) = (AsnOcts*) Asn1Alloc(sizeof(AsnOcts));
    CheckAsn1Alloc((v->a.type_100), env);
    BDecAsnOctsContent( b, tagId1, elmtLen1, (v->a.type_100), &totalElmtsLen1, env);
    if (elmtLen0 == INDEFINITE_LEN)
        BDecEoc(b, &totalElmtsLen1, env);
    break;

       case(MAKE_TAG_ID( CNTX, PRIM, 101)):
       case(MAKE_TAG_ID( CNTX, CONS, 101)):
        (v->choiceId) = QUERY_TYPE_101;
    (v->a.type_101) = (AsnOcts*) Asn1Alloc(sizeof(AsnOcts));
    CheckAsn1Alloc((v->a.type_101), env);
    BDecAsnOctsContent( b, tagId0, elmtLen0, (v->a.type_101), &totalElmtsLen1, env);
    break;

    default:
        Asn1Error("ERROR - unexpected tag in CHOICE\n");
        longjmp(env, -220);
        break;
    } /* end switch */
    (*bytesDecoded) += totalElmtsLen1;
}  /* BDecQueryContent */

void
PrintQuery PARAMS((f, v, indent),
FILE* f _AND_
Query* v _AND_
unsigned short int indent)
{
    switch(v->choiceId)
    {
      case(QUERY_TYPE_0):
          fprintf(f,"type-0 ");
    PrintAsnOcts(f, (v->a.type_0), indent + stdIndentG);
          break;

      case(QUERY_TYPE_1):
          fprintf(f,"type-1 ");
    PrintRPNQuery(f, (v->a.type_1), indent + stdIndentG);
          break;

      case(QUERY_TYPE_2):
          fprintf(f,"type-2 ");
    PrintAsnOcts(f, (v->a.type_2), indent + stdIndentG);
          break;

      case(QUERY_TYPE_100):
          fprintf(f,"type-100 ");
    PrintAsnOcts(f, (v->a.type_100), indent + stdIndentG);
          break;

      case(QUERY_TYPE_101):
          fprintf(f,"type-101 ");
    PrintAsnOcts(f, (v->a.type_101), indent + stdIndentG);
          break;

    }
}  /* PrintQuery */

void
FreeQuery PARAMS((v),
Query* v)
{

    if (v == NULL)
        return;
    switch(v->choiceId)
    {
       case(QUERY_TYPE_0):
    FreeAsnOcts((v->a.type_0));
    Asn1Free((v->a.type_0));

    break;

       case(QUERY_TYPE_1):
    FreeRPNQuery((v->a.type_1));
    Asn1Free((v->a.type_1));

    break;

       case(QUERY_TYPE_2):
    FreeAsnOcts((v->a.type_2));
    Asn1Free((v->a.type_2));

    break;

       case(QUERY_TYPE_100):
    FreeAsnOcts((v->a.type_100));
    Asn1Free((v->a.type_100));

    break;

       case(QUERY_TYPE_101):
    FreeAsnOcts((v->a.type_101));
    Asn1Free((v->a.type_101));

    break;

    }
}  /* FreeQuery */




AsnLen
BEncSearchReqContent PARAMS((b, v),
BUF_TYPE b _AND_
SearchReq* v)
{
    AsnLen totalLen = 0;
    AsnLen itemLen;
    AsnLen listLen;
    void* component;

    BEncEocIfNec(b);
    itemLen = BEncQueryContent( b, (v->query));
    itemLen += BEncConsLen( b, itemLen);
    itemLen += BEncTag1(b, CNTX, CONS, 21);

    totalLen += itemLen;

    if (ASNOID_PRESENT((&v->preferredRecordSyntax)))
    {
    itemLen = BEncPreferredRecordSyntaxContent( b, (&v->preferredRecordSyntax));
    itemLen += BEncDefLen( b, itemLen);
    itemLen += BEncTag2(b, CNTX, PRIM, 104);

    totalLen += itemLen;
    }

    if (NOT_NULL((v->mediumSetElementSetNames)))
    {
    BEncEocIfNec(b);
    itemLen = BEncElementSetNamesContent( b, (v->mediumSetElementSetNames));
    itemLen += BEncConsLen( b, itemLen);
    itemLen += BEncTag2(b, CNTX, CONS, 101);

    totalLen += itemLen;
    }

    if (NOT_NULL((v->smallSetElementSetNames)))
    {
    BEncEocIfNec(b);
    itemLen = BEncElementSetNamesContent( b, (v->smallSetElementSetNames));
    itemLen += BEncConsLen( b, itemLen);
    itemLen += BEncTag2(b, CNTX, CONS, 100);

    totalLen += itemLen;
    }

    BEncEocIfNec(b);
    itemLen = BEncSearchReqSeqOfContent( b, (v->databaseNames));
    itemLen += BEncConsLen( b, itemLen);
    itemLen += BEncTag1(b, CNTX, CONS, 18);

    totalLen += itemLen;

    itemLen = BEncVisibleStringContent( b, (&v->resultSetName));
    itemLen += BEncDefLen( b, itemLen);
    itemLen += BEncTag1(b, CNTX, PRIM, 17);

    totalLen += itemLen;

    itemLen = BEncAsnBoolContent( b, (&v->replaceIndicator));
    BEncDefLenTo127( b, itemLen);
    itemLen++;
    itemLen += BEncTag1(b, CNTX, PRIM, 16);

    totalLen += itemLen;

    itemLen = BEncAsnIntContent( b, (&v->mediumSetPresentNum));
    BEncDefLenTo127( b, itemLen);
    itemLen++;
    itemLen += BEncTag1(b, CNTX, PRIM, 15);

    totalLen += itemLen;

    itemLen = BEncAsnIntContent( b, (&v->largeSetLowerBound));
    BEncDefLenTo127( b, itemLen);
    itemLen++;
    itemLen += BEncTag1(b, CNTX, PRIM, 14);

    totalLen += itemLen;

    itemLen = BEncAsnIntContent( b, (&v->smallSetUpperBound));
    BEncDefLenTo127( b, itemLen);
    itemLen++;
    itemLen += BEncTag1(b, CNTX, PRIM, 13);

    totalLen += itemLen;

    if (ASNOCTS_PRESENT((&v->referenceId)))
    {
    itemLen = BEncReferenceIdContent( b, (&v->referenceId));
    itemLen += BEncDefLen( b, itemLen);
    itemLen += BEncTag1(b, CNTX, PRIM, 2);

    totalLen += itemLen;
    }

    return (totalLen);

}  /* BEncSearchReqContent */

void
BDecSearchReqContent PARAMS((b, tagId0, elmtLen0, v, bytesDecoded, env),
BUF_TYPE b _AND_
AsnTag tagId0 _AND_
AsnLen elmtLen0 _AND_
SearchReq* v _AND_
AsnLen* bytesDecoded _AND_
ENV_TYPE env)
{
    int seqDone = FALSE;
    AsnLen totalElmtsLen1 = 0;
    AsnLen elmtLen1;
    AsnTag tagId1;
    int mandatoryElmtCount1 = 0;
    AsnLen totalElmtsLen2 = 0;
    AsnLen elmtLen2;
    AsnTag tagId2;
    AsnLen totalElmtsLen3 = 0;
    AsnLen elmtLen3;
    AsnTag tagId3;


    tagId1 = BDecTag(b, &totalElmtsLen1, env);

    if ((( tagId1 == MAKE_TAG_ID( CNTX, PRIM, 2)) ||
( tagId1 == MAKE_TAG_ID( CNTX, CONS, 2))))
    {
    elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
    BDecReferenceIdContent( b, tagId1, elmtLen1, (&v->referenceId), &totalElmtsLen1, env);
    tagId1 = BDecTag(b, &totalElmtsLen1, env);
    }


    if ((( tagId1 == MAKE_TAG_ID( CNTX, PRIM, 13))))
    {
    elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
    BDecAsnIntContent( b, tagId1, elmtLen1, (&v->smallSetUpperBound), &totalElmtsLen1, env);
    tagId1 = BDecTag(b, &totalElmtsLen1, env);
    }
    else
        longjmp(env, -221);


    if ((( tagId1 == MAKE_TAG_ID( CNTX, PRIM, 14))))
    {
    elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
    BDecAsnIntContent( b, tagId1, elmtLen1, (&v->largeSetLowerBound), &totalElmtsLen1, env);
    tagId1 = BDecTag(b, &totalElmtsLen1, env);
    }
    else
        longjmp(env, -222);


    if ((( tagId1 == MAKE_TAG_ID( CNTX, PRIM, 15))))
    {
    elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
    BDecAsnIntContent( b, tagId1, elmtLen1, (&v->mediumSetPresentNum), &totalElmtsLen1, env);
    tagId1 = BDecTag(b, &totalElmtsLen1, env);
    }
    else
        longjmp(env, -223);


    if ((( tagId1 == MAKE_TAG_ID( CNTX, PRIM, 16))))
    {
    elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
    BDecAsnBoolContent( b, tagId1, elmtLen1, (&v->replaceIndicator), &totalElmtsLen1, env);
    tagId1 = BDecTag(b, &totalElmtsLen1, env);
    }
    else
        longjmp(env, -224);


    if ((( tagId1 == MAKE_TAG_ID( CNTX, PRIM, 17)) ||
( tagId1 == MAKE_TAG_ID( CNTX, CONS, 17))))
    {
    elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
    BDecVisibleStringContent( b, tagId1, elmtLen1, (&v->resultSetName), &totalElmtsLen1, env);
    tagId1 = BDecTag(b, &totalElmtsLen1, env);
    }
    else
        longjmp(env, -225);


    if ((( tagId1 == MAKE_TAG_ID( CNTX, CONS, 18))))
    {
    elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
    (v->databaseNames) = AsnListNew(sizeof(char*));
    CheckAsn1Alloc((v->databaseNames), env);
    BDecSearchReqSeqOfContent( b, tagId1, elmtLen1, (v->databaseNames), &totalElmtsLen1, env);
    tagId1 = BDecTag(b, &totalElmtsLen1, env);
    }
    else
        longjmp(env, -226);


    if ((( tagId1 == MAKE_TAG_ID( CNTX, CONS, 100))))
    {
    elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
    (v->smallSetElementSetNames) = (ElementSetNames*) Asn1Alloc(sizeof(ElementSetNames));
    CheckAsn1Alloc((v->smallSetElementSetNames), env);
    tagId2 = BDecTag(b, &totalElmtsLen1, env);
    elmtLen2 = BDecLen (b, &totalElmtsLen1, env);
    BDecElementSetNamesContent( b, tagId2, elmtLen2, (v->smallSetElementSetNames), &totalElmtsLen1, env);
    if (elmtLen1 == INDEFINITE_LEN)
        BDecEoc(b, &totalElmtsLen1, env);
    tagId1 = BDecTag(b, &totalElmtsLen1, env);
    }


    if ((( tagId1 == MAKE_TAG_ID( CNTX, CONS, 101))))
    {
    elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
    (v->mediumSetElementSetNames) = (ElementSetNames*) Asn1Alloc(sizeof(ElementSetNames));
    CheckAsn1Alloc((v->mediumSetElementSetNames), env);
    tagId2 = BDecTag(b, &totalElmtsLen1, env);
    elmtLen2 = BDecLen (b, &totalElmtsLen1, env);
    BDecElementSetNamesContent( b, tagId2, elmtLen2, (v->mediumSetElementSetNames), &totalElmtsLen1, env);
    if (elmtLen1 == INDEFINITE_LEN)
        BDecEoc(b, &totalElmtsLen1, env);
    tagId1 = BDecTag(b, &totalElmtsLen1, env);
    }


    if ((( tagId1 == MAKE_TAG_ID( CNTX, PRIM, 104))))
    {
    elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
    BDecPreferredRecordSyntaxContent( b, tagId1, elmtLen1, (&v->preferredRecordSyntax), &totalElmtsLen1, env);
    tagId1 = BDecTag(b, &totalElmtsLen1, env);
    }


    if ((( tagId1 == MAKE_TAG_ID( CNTX, CONS, 21))))
    {
    elmtLen1 = BDecLen (b, &totalElmtsLen1, env);
    (v->query) = (Query*) Asn1Alloc(sizeof(Query));
    CheckAsn1Alloc((v->query), env);
    tagId2 = BDecTag(b, &totalElmtsLen1, env);
    elmtLen2 = BDecLen (b, &totalElmtsLen1, env);
    BDecQueryContent( b, tagId2, elmtLen2, (v->query), &totalElmtsLen1, env);
    if (elmtLen1 == INDEFINITE_LEN)
        BDecEoc(b, &totalElmtsLen1, env);
        seqDone = TRUE;
        if ( elmtLen0 == INDEFINITE_LEN )
            BDecEoc(b, &totalElmtsLen1, env);
        else if (totalElmtsLen1 != elmtLen0)
            longjmp(env, -227);
    }
    else
        longjmp(env, -228);


    if (!seqDone)
        longjmp(env, -229);

    (*bytesDecoded) += totalElmtsLen1;
}  /* BDecSearchReqContent */

void
PrintSearchReq PARAMS((f, v, indent),
FILE* f _AND_
SearchReq* v _AND_
unsigned short int indent)
{
    if (v == NULL)
        return;

    fprintf(f,"{ -- SEQUENCE --\n");

    if ( ASNOCTS_PRESENT((&v->referenceId)))
    {
    Indent(f, indent + stdIndentG);
    fprintf(f,"referenceId ");
    PrintReferenceId(f, (&v->referenceId), indent + stdIndentG);
    fprintf(f, ",\n");
    }
    Indent(f, indent + stdIndentG);
    fprintf(f,"smallSetUpperBound ");
    PrintAsnInt(f, (&v->smallSetUpperBound), indent + stdIndentG);
    fprintf(f, ",\n");
    Indent(f, indent + stdIndentG);
    fprintf(f,"largeSetLowerBound ");
    PrintAsnInt(f, (&v->largeSetLowerBound), indent + stdIndentG);
    fprintf(f, ",\n");
    Indent(f, indent + stdIndentG);
    fprintf(f,"mediumSetPresentNum ");
    PrintAsnInt(f, (&v->mediumSetPresentNum), indent + stdIndentG);
    fprintf(f, ",\n");
    Indent(f, indent + stdIndentG);
    fprintf(f,"replaceIndicator ");
    PrintAsnBool(f, (&v->replaceIndicator), indent + stdIndentG);
    fprintf(f, ",\n");
    Indent(f, indent + stdIndentG);
    fprintf(f,"resultSetName ");
    PrintVisibleString(f, (&v->resultSetName), indent + stdIndentG);
    fprintf(f, ",\n");
    Indent(f, indent + stdIndentG);
    fprintf(f,"databaseNames ");
    PrintSearchReqSeqOf(f, (v->databaseNames), indent + stdIndentG);
    fprintf(f, ",\n");
    if ( NOT_NULL((v->smallSetElementSetNames)))
    {
    Indent(f, indent + stdIndentG);
    fprintf(f,"smallSetElementSetNames ");
    PrintElementSetNames(f, (v->smallSetElementSetNames), indent + stdIndentG);
    fprintf(f, ",\n");
    }
    if ( NOT_NULL((v->mediumSetElementSetNames)))
    {
    Indent(f, indent + stdIndentG);
    fprintf(f,"mediumSetElementSetNames ");
    PrintElementSetNames(f, (v->mediumSetElementSetNames), indent + stdIndentG);
    fprintf(f, ",\n");
    }
    if ( ASNOID_PRESENT((&v->preferredRecordSyntax)))
    {
    Indent(f, indent + stdIndentG);
    fprintf(f,"preferredRecordSyntax ");
    PrintPreferredRecordSyntax(f, (&v->preferredRecordSyntax), indent + stdIndentG);
    fprintf(f, ",\n");
    }
    Indent(f, indent + stdIndentG);
    fprintf(f,"query ");
    PrintQuery(f, (v->query), indent + stdIndentG);
    fprintf(f,"\n");
    Indent(f, indent);
    fprintf(f,"}");
}  /* PrintSearchReq */

void
FreeSearchReq PARAMS((v),
SearchReq* v)
{

    if (v == NULL)
        return;
    if ( ASNOCTS_PRESENT((&v->referenceId)))
    {
    FreeReferenceId((&v->referenceId));
    }

    FreeAsnInt((&v->smallSetUpperBound));

    FreeAsnInt((&v->largeSetLowerBound));

    FreeAsnInt((&v->mediumSetPresentNum));

    FreeAsnBool((&v->replaceIndicator));

    FreeVisibleString((&v->resultSetName));

    FreeSearchReqSeqOf((v->databaseNames));
    Asn1Free((v->databaseNames));

    if ( NOT_NULL((v->smallSetElementSetNames)))
    {
    FreeElementSetNames((v->smallSetElementSetNames));
    Asn1Free((v->smallSetElementSetNames));
    }

    if ( NOT_NULL((v->mediumSetElementSetNames)))
    {
    FreeElementSetNames((v->mediumSetElementSetNames));
    Asn1Free((v->mediumSetElementSetNames));
    }

    if ( ASNOID_PRESENT((&v->preferredRecordSyntax)))
    {
    FreePreferredRecordSyntax((&v->preferredRecordSyntax));
    }

    FreeQuery((v->query));
    Asn1Free((v->query));

}  /* FreeSearchReq */




AsnLen BEncAPDU PARAMS((b, v),
BUF_TYPE b _AND_
APDU* v)
{
    AsnLen l;
    l = BEncAPDUContent(b, v);
    return(l);
} /* BEncAPDU */

void BDecAPDU PARAMS((b, result, bytesDecoded, env),
BUF_TYPE b _AND_
APDU* result _AND_
AsnLen* bytesDecoded _AND_
ENV_TYPE env)
{
    AsnTag tag;
    AsnLen elmtLen1;

    tag = BDecTag(b, bytesDecoded, env);
    elmtLen1 = BDecLen(b, bytesDecoded, env);
    BDecAPDUContent(b, tag, elmtLen1, result, bytesDecoded, env);
}  /* BDecAPDU */

AsnLen
BEncAPDUContent PARAMS((b, v),
BUF_TYPE b _AND_
APDU* v)
{
    AsnLen totalLen = 0;
    AsnLen itemLen;
    AsnLen listLen;
    void* component;

    switch(v->choiceId)
    {
       case(APDU_INITREQ):
    BEncEocIfNec(b);
    itemLen = BEncInitializeReqContent( b, (v->a.initReq));
    itemLen += BEncConsLen( b, itemLen);
    itemLen += BEncTag1(b, CNTX, CONS, 20);

    totalLen += itemLen;

    break;

       case(APDU_INITRESP):
    BEncEocIfNec(b);
    itemLen = BEncInitializeRespContent( b, (v->a.initResp));
    itemLen += BEncConsLen( b, itemLen);
    itemLen += BEncTag1(b, CNTX, CONS, 21);

    totalLen += itemLen;

    break;

       case(APDU_SEARCHREQ):
    BEncEocIfNec(b);
    itemLen = BEncSearchReqContent( b, (v->a.searchReq));
    itemLen += BEncConsLen( b, itemLen);
    itemLen += BEncTag1(b, CNTX, CONS, 22);

    totalLen += itemLen;

    break;

       case(APDU_SEARCHRESP):
    BEncEocIfNec(b);
    itemLen = BEncSearchRespContent( b, (v->a.searchResp));
    itemLen += BEncConsLen( b, itemLen);
    itemLen += BEncTag1(b, CNTX, CONS, 23);

    totalLen += itemLen;

    break;

       case(APDU_PRESENTREQ):
    BEncEocIfNec(b);
    itemLen = BEncPresentReqContent( b, (v->a.presentReq));
    itemLen += BEncConsLen( b, itemLen);
    itemLen += BEncTag1(b, CNTX, CONS, 24);

    totalLen += itemLen;

    break;

       case(APDU_PRESENTRESP):
    BEncEocIfNec(b);
    itemLen = BEncPresentRespContent( b, (v->a.presentResp));
    itemLen += BEncConsLen( b, itemLen);
    itemLen += BEncTag1(b, CNTX, CONS, 25);

    totalLen += itemLen;

    break;

       case(APDU_DELETERESULTSETREQ):
    BEncEocIfNec(b);
    itemLen = BEncDeleteResultSetReqContent( b, (v->a.deleteResultSetReq));
    itemLen += BEncConsLen( b, itemLen);
    itemLen += BEncTag1(b, CNTX, CONS, 26);

    totalLen += itemLen;

    break;

       case(APDU_DELETERESULTSETRESP):
    BEncEocIfNec(b);
    itemLen = BEncDeleteResultSetRespContent( b, (v->a.deleteResultSetResp));
    itemLen += BEncConsLen( b, itemLen);
    itemLen += BEncTag1(b, CNTX, CONS, 27);

    totalLen += itemLen;

    break;

       case(APDU_ACCESSCONTROLREQ):
    BEncEocIfNec(b);
    itemLen = BEncAccessControlReqContent( b, (v->a.accessControlReq));
    itemLen += BEncConsLen( b, itemLen);
    itemLen += BEncTag1(b, CNTX, CONS, 28);

    totalLen += itemLen;

    break;

       case(APDU_ACCESSCONTROLRESP):
    BEncEocIfNec(b);
    itemLen = BEncAccessControlRespContent( b, (v->a.accessControlResp));
    itemLen += BEncConsLen( b, itemLen);
    itemLen += BEncTag1(b, CNTX, CONS, 29);

    totalLen += itemLen;

    break;

       case(APDU_RESOURCECONTROLREQ):
    BEncEocIfNec(b);
    itemLen = BEncResourceControlReqContent( b, (v->a.resourceControlReq));
    itemLen += BEncConsLen( b, itemLen);
    itemLen += BEncTag1(b, CNTX, CONS, 30);

    totalLen += itemLen;

    break;

       case(APDU_RESOURCECONTROLRESP):
    BEncEocIfNec(b);
    itemLen = BEncResourceControlRespContent( b, (v->a.resourceControlResp));
    itemLen += BEncConsLen( b, itemLen);
    itemLen += BEncTag2(b, CNTX, CONS, 31);

    totalLen += itemLen;

    break;

       case(APDU_TRIGGERRESOURCEREQ):
    BEncEocIfNec(b);
    itemLen = BEncTriggerResourceReqContent( b, (v->a.triggerResourceReq));
    itemLen += BEncConsLen( b, itemLen);
    itemLen += BEncTag2(b, CNTX, CONS, 32);

    totalLen += itemLen;

    break;

       case(APDU_RESOURCEREPORTREQ):
    BEncEocIfNec(b);
    itemLen = BEncResourceReportReqContent( b, (v->a.resourceReportReq));
    itemLen += BEncConsLen( b, itemLen);
    itemLen += BEncTag2(b, CNTX, CONS, 33);

    totalLen += itemLen;

    break;

       case(APDU_RESOURCEREPORTRESP):
    BEncEocIfNec(b);
    itemLen = BEncResourceReportRespContent( b, (v->a.resourceReportResp));
    itemLen += BEncConsLen( b, itemLen);
    itemLen += BEncTag2(b, CNTX, CONS, 34);

    totalLen += itemLen;

    break;

    }
    return (totalLen);

}  /* BEncAPDUContent */

void
BDecAPDUContent PARAMS((b, tagId0, elmtLen0, v, bytesDecoded, env),
BUF_TYPE b _AND_
AsnTag tagId0 _AND_
AsnLen elmtLen0 _AND_
APDU* v _AND_
AsnLen* bytesDecoded _AND_
ENV_TYPE env)
{
    int seqDone = FALSE;
    AsnLen totalElmtsLen1 = 0;
    AsnLen elmtLen1;
    AsnTag tagId1;
    int mandatoryElmtCount1 = 0;


    switch(tagId0)
    {
       case(MAKE_TAG_ID( CNTX, CONS, 20)):
        (v->choiceId) = APDU_INITREQ;
    (v->a.initReq) = (InitializeReq*) Asn1Alloc(sizeof(InitializeReq));
    CheckAsn1Alloc((v->a.initReq), env);
    BDecInitializeReqContent( b, tagId0, elmtLen0, (v->a.initReq), &totalElmtsLen1, env);
    break;

       case(MAKE_TAG_ID( CNTX, CONS, 21)):
        (v->choiceId) = APDU_INITRESP;
    (v->a.initResp) = (InitializeResp*) Asn1Alloc(sizeof(InitializeResp));
    CheckAsn1Alloc((v->a.initResp), env);
    BDecInitializeRespContent( b, tagId0, elmtLen0, (v->a.initResp), &totalElmtsLen1, env);
    break;

       case(MAKE_TAG_ID( CNTX, CONS, 22)):
        (v->choiceId) = APDU_SEARCHREQ;
    (v->a.searchReq) = (SearchReq*) Asn1Alloc(sizeof(SearchReq));
    CheckAsn1Alloc((v->a.searchReq), env);
    BDecSearchReqContent( b, tagId0, elmtLen0, (v->a.searchReq), &totalElmtsLen1, env);
    break;

       case(MAKE_TAG_ID( CNTX, CONS, 23)):
        (v->choiceId) = APDU_SEARCHRESP;
    (v->a.searchResp) = (SearchResp*) Asn1Alloc(sizeof(SearchResp));
    CheckAsn1Alloc((v->a.searchResp), env);
    BDecSearchRespContent( b, tagId0, elmtLen0, (v->a.searchResp), &totalElmtsLen1, env);
    break;

       case(MAKE_TAG_ID( CNTX, CONS, 24)):
        (v->choiceId) = APDU_PRESENTREQ;
    (v->a.presentReq) = (PresentReq*) Asn1Alloc(sizeof(PresentReq));
    CheckAsn1Alloc((v->a.presentReq), env);
    BDecPresentReqContent( b, tagId0, elmtLen0, (v->a.presentReq), &totalElmtsLen1, env);
    break;

       case(MAKE_TAG_ID( CNTX, CONS, 25)):
        (v->choiceId) = APDU_PRESENTRESP;
    (v->a.presentResp) = (PresentResp*) Asn1Alloc(sizeof(PresentResp));
    CheckAsn1Alloc((v->a.presentResp), env);
    BDecPresentRespContent( b, tagId0, elmtLen0, (v->a.presentResp), &totalElmtsLen1, env);
    break;

       case(MAKE_TAG_ID( CNTX, CONS, 26)):
        (v->choiceId) = APDU_DELETERESULTSETREQ;
    (v->a.deleteResultSetReq) = (DeleteResultSetReq*) Asn1Alloc(sizeof(DeleteResultSetReq));
    CheckAsn1Alloc((v->a.deleteResultSetReq), env);
    BDecDeleteResultSetReqContent( b, tagId0, elmtLen0, (v->a.deleteResultSetReq), &totalElmtsLen1, env);
    break;

       case(MAKE_TAG_ID( CNTX, CONS, 27)):
        (v->choiceId) = APDU_DELETERESULTSETRESP;
    (v->a.deleteResultSetResp) = (DeleteResultSetResp*) Asn1Alloc(sizeof(DeleteResultSetResp));
    CheckAsn1Alloc((v->a.deleteResultSetResp), env);
    BDecDeleteResultSetRespContent( b, tagId0, elmtLen0, (v->a.deleteResultSetResp), &totalElmtsLen1, env);
    break;

       case(MAKE_TAG_ID( CNTX, CONS, 28)):
        (v->choiceId) = APDU_ACCESSCONTROLREQ;
    (v->a.accessControlReq) = (AccessControlReq*) Asn1Alloc(sizeof(AccessControlReq));
    CheckAsn1Alloc((v->a.accessControlReq), env);
    BDecAccessControlReqContent( b, tagId0, elmtLen0, (v->a.accessControlReq), &totalElmtsLen1, env);
    break;

       case(MAKE_TAG_ID( CNTX, CONS, 29)):
        (v->choiceId) = APDU_ACCESSCONTROLRESP;
    (v->a.accessControlResp) = (AccessControlResp*) Asn1Alloc(sizeof(AccessControlResp));
    CheckAsn1Alloc((v->a.accessControlResp), env);
    BDecAccessControlRespContent( b, tagId0, elmtLen0, (v->a.accessControlResp), &totalElmtsLen1, env);
    break;

       case(MAKE_TAG_ID( CNTX, CONS, 30)):
        (v->choiceId) = APDU_RESOURCECONTROLREQ;
    (v->a.resourceControlReq) = (ResourceControlReq*) Asn1Alloc(sizeof(ResourceControlReq));
    CheckAsn1Alloc((v->a.resourceControlReq), env);
    BDecResourceControlReqContent( b, tagId0, elmtLen0, (v->a.resourceControlReq), &totalElmtsLen1, env);
    break;

       case(MAKE_TAG_ID( CNTX, CONS, 31)):
        (v->choiceId) = APDU_RESOURCECONTROLRESP;
    (v->a.resourceControlResp) = (ResourceControlResp*) Asn1Alloc(sizeof(ResourceControlResp));
    CheckAsn1Alloc((v->a.resourceControlResp), env);
    BDecResourceControlRespContent( b, tagId0, elmtLen0, (v->a.resourceControlResp), &totalElmtsLen1, env);
    break;

       case(MAKE_TAG_ID( CNTX, CONS, 32)):
        (v->choiceId) = APDU_TRIGGERRESOURCEREQ;
    (v->a.triggerResourceReq) = (TriggerResourceReq*) Asn1Alloc(sizeof(TriggerResourceReq));
    CheckAsn1Alloc((v->a.triggerResourceReq), env);
    BDecTriggerResourceReqContent( b, tagId0, elmtLen0, (v->a.triggerResourceReq), &totalElmtsLen1, env);
    break;

       case(MAKE_TAG_ID( CNTX, CONS, 33)):
        (v->choiceId) = APDU_RESOURCEREPORTREQ;
    (v->a.resourceReportReq) = (ResourceReportReq*) Asn1Alloc(sizeof(ResourceReportReq));
    CheckAsn1Alloc((v->a.resourceReportReq), env);
    BDecResourceReportReqContent( b, tagId0, elmtLen0, (v->a.resourceReportReq), &totalElmtsLen1, env);
    break;

       case(MAKE_TAG_ID( CNTX, CONS, 34)):
        (v->choiceId) = APDU_RESOURCEREPORTRESP;
    (v->a.resourceReportResp) = (ResourceReportResp*) Asn1Alloc(sizeof(ResourceReportResp));
    CheckAsn1Alloc((v->a.resourceReportResp), env);
    BDecResourceReportRespContent( b, tagId0, elmtLen0, (v->a.resourceReportResp), &totalElmtsLen1, env);
    break;

    default:
        Asn1Error("ERROR - unexpected tag in CHOICE\n");
        longjmp(env, -230);
        break;
    } /* end switch */
    (*bytesDecoded) += totalElmtsLen1;
}  /* BDecAPDUContent */

void
PrintAPDU PARAMS((f, v, indent),
FILE* f _AND_
APDU* v _AND_
unsigned short int indent)
{
    switch(v->choiceId)
    {
      case(APDU_INITREQ):
          fprintf(f,"initReq ");
    PrintInitializeReq(f, (v->a.initReq), indent + stdIndentG);
          break;

      case(APDU_INITRESP):
          fprintf(f,"initResp ");
    PrintInitializeResp(f, (v->a.initResp), indent + stdIndentG);
          break;

      case(APDU_SEARCHREQ):
          fprintf(f,"searchReq ");
    PrintSearchReq(f, (v->a.searchReq), indent + stdIndentG);
          break;

      case(APDU_SEARCHRESP):
          fprintf(f,"searchResp ");
    PrintSearchResp(f, (v->a.searchResp), indent + stdIndentG);
          break;

      case(APDU_PRESENTREQ):
          fprintf(f,"presentReq ");
    PrintPresentReq(f, (v->a.presentReq), indent + stdIndentG);
          break;

      case(APDU_PRESENTRESP):
          fprintf(f,"presentResp ");
    PrintPresentResp(f, (v->a.presentResp), indent + stdIndentG);
          break;

      case(APDU_DELETERESULTSETREQ):
          fprintf(f,"deleteResultSetReq ");
    PrintDeleteResultSetReq(f, (v->a.deleteResultSetReq), indent + stdIndentG);
          break;

      case(APDU_DELETERESULTSETRESP):
          fprintf(f,"deleteResultSetResp ");
    PrintDeleteResultSetResp(f, (v->a.deleteResultSetResp), indent + stdIndentG);
          break;

      case(APDU_ACCESSCONTROLREQ):
          fprintf(f,"accessControlReq ");
    PrintAccessControlReq(f, (v->a.accessControlReq), indent + stdIndentG);
          break;

      case(APDU_ACCESSCONTROLRESP):
          fprintf(f,"accessControlResp ");
    PrintAccessControlResp(f, (v->a.accessControlResp), indent + stdIndentG);
          break;

      case(APDU_RESOURCECONTROLREQ):
          fprintf(f,"resourceControlReq ");
    PrintResourceControlReq(f, (v->a.resourceControlReq), indent + stdIndentG);
          break;

      case(APDU_RESOURCECONTROLRESP):
          fprintf(f,"resourceControlResp ");
    PrintResourceControlResp(f, (v->a.resourceControlResp), indent + stdIndentG);
          break;

      case(APDU_TRIGGERRESOURCEREQ):
          fprintf(f,"triggerResourceReq ");
    PrintTriggerResourceReq(f, (v->a.triggerResourceReq), indent + stdIndentG);
          break;

      case(APDU_RESOURCEREPORTREQ):
          fprintf(f,"resourceReportReq ");
    PrintResourceReportReq(f, (v->a.resourceReportReq), indent + stdIndentG);
          break;

      case(APDU_RESOURCEREPORTRESP):
          fprintf(f,"resourceReportResp ");
    PrintResourceReportResp(f, (v->a.resourceReportResp), indent + stdIndentG);
          break;

    }
}  /* PrintAPDU */

void
FreeAPDU PARAMS((v),
APDU* v)
{

    if (v == NULL)
        return;
    switch(v->choiceId)
    {
       case(APDU_INITREQ):
    FreeInitializeReq((v->a.initReq));
    Asn1Free((v->a.initReq));

    break;

       case(APDU_INITRESP):
    FreeInitializeResp((v->a.initResp));
    Asn1Free((v->a.initResp));

    break;

       case(APDU_SEARCHREQ):
    FreeSearchReq((v->a.searchReq));
    Asn1Free((v->a.searchReq));

    break;

       case(APDU_SEARCHRESP):
    FreeSearchResp((v->a.searchResp));
    Asn1Free((v->a.searchResp));

    break;

       case(APDU_PRESENTREQ):
    FreePresentReq((v->a.presentReq));
    Asn1Free((v->a.presentReq));

    break;

       case(APDU_PRESENTRESP):
    FreePresentResp((v->a.presentResp));
    Asn1Free((v->a.presentResp));

    break;

       case(APDU_DELETERESULTSETREQ):
    FreeDeleteResultSetReq((v->a.deleteResultSetReq));
    Asn1Free((v->a.deleteResultSetReq));

    break;

       case(APDU_DELETERESULTSETRESP):
    FreeDeleteResultSetResp((v->a.deleteResultSetResp));
    Asn1Free((v->a.deleteResultSetResp));

    break;

       case(APDU_ACCESSCONTROLREQ):
    FreeAccessControlReq((v->a.accessControlReq));
    Asn1Free((v->a.accessControlReq));

    break;

       case(APDU_ACCESSCONTROLRESP):
    FreeAccessControlResp((v->a.accessControlResp));
    Asn1Free((v->a.accessControlResp));

    break;

       case(APDU_RESOURCECONTROLREQ):
    FreeResourceControlReq((v->a.resourceControlReq));
    Asn1Free((v->a.resourceControlReq));

    break;

       case(APDU_RESOURCECONTROLRESP):
    FreeResourceControlResp((v->a.resourceControlResp));
    Asn1Free((v->a.resourceControlResp));

    break;

       case(APDU_TRIGGERRESOURCEREQ):
    FreeTriggerResourceReq((v->a.triggerResourceReq));
    Asn1Free((v->a.triggerResourceReq));

    break;

       case(APDU_RESOURCEREPORTREQ):
    FreeResourceReportReq((v->a.resourceReportReq));
    Asn1Free((v->a.resourceReportReq));

    break;

       case(APDU_RESOURCEREPORTRESP):
    FreeResourceReportResp((v->a.resourceReportResp));
    Asn1Free((v->a.resourceReportResp));

    break;

    }
}  /* FreeAPDU */




