
/************************************************************************
 *
 * SR/Z3950 application software version 1.0, August 1993.
 *
 * (C) Software Kinetics Ltd.
 *
 * Software Kinetics Ltd. has granted a licence of this software to the
 * National Library of Canada.
 *
 * The National Library of Canada grants to the user a royalty-free
 * non-exclusive licence in perpetuity to use, modify, improve, reproduce
 * and sell the software.
 *
 * The software is provided to the user "as is" without warranty of any
 * kind. Neither Software Kinetics Ltd. nor the National Library of Canada
 * warrants, guarantees or makes any representations regarding the use,
 * or the results of use of the software in terms of accuracy, reliability,
 * or otherwise. The entire risk as to results and performance of the
 * software is assumed by the user. Neither Software Kinetics Ltd. nor the
 * National Library of Canada shall be liable for any direct, indirect,
 * consequential or incidental damages arising out of the use of the
 * software.
 *
 * $Log:
 * Revision 1.1  1993/09/16  09:03:27  irorigin
 * Baseline for Release 1.0.
 *
 ************************************************************************/

#include <ir.h>
#include <ir_api.h>
#include <ua.h>
#include <resc.h>
#include <resclist.h>
#include <debug.h>
#include <uaep.h>


void UaAc_CommStatusUpdate()
{
	IR_LIST			assocList;
	IRO_ASSOC_STRUCT	*assocElem;
	CHAR			tmpBuf[40];
	CHAR			dispBuf[90];
	SHORT			index;
	CHAR			*s;

	RESC_ASN_NO_MALLOC(&assocList);
	RESC_LIST_INIT(&assocList);
	if (UaAc_GetAssociationInfo(UAAC_GET_ALL_ASSOCS, IR_UNKNOWN_ID_TYPE,
	    &assocList) == IR_FAIL)
	{
		CS_LOG_PRINTS(IR_FILE, "Couldn't get assoc info for all targets\n");
		return;
	}

	/* 
	 * For each target generate an slist containing the database
	 * name and a pointer to the database name structure.
	 */

	RESC_LIST_SET_FIRST(&assocList);
	strcpy(tmpBuf, "");
	for (index = 0; index < RESC_LIST_SIZE(&assocList); index++)
	{
		assocElem = RESC_LIST_GET(&assocList);


		s = &tmpBuf[strlen(tmpBuf)];
		sprintf(s, " , %1d=%c", (index+1), 
		    GET_ASSOC_CHAR(assocElem->state));

		RESC_LIST_SET_NEXT(&assocList);
	}

	RescList_Destroy(IR_FILE, &assocList);

	if (index == 0)
	{
		sprintf(dispBuf, "CANSEARCH");
	}
	else
	{
		sprintf(dispBuf, "CANSEARCH[Comm Status%s]", tmpBuf);
	}

	set_title(TASK_WIN, dispBuf);
}
	

	
