/*
	This file was generated by XVT-Design 2.0, a product of:

		XVT Software Inc.
		4900 Pearl East Circle
		Boulder, CO USA 80301
		303-443-4223, fax 303-443-0969

	Generated on Wed May 11 09:27:48 1994
*/

#include "xvt.h"
#include "uaep.h"

/* 
	Information about the dialog
*/
#define DLG_RES_ID DLG_RESULT_DISPLAY
#define DLG_FLAGS 0x0L
#define DLG_CLASS ""
#define DLG_MODE WD_MODAL
/************************************************************************
 *
 * SR/Z3950 application software version 1.0, August 1993.
 *
 * (C) Software Kinetics Ltd.
 *
 * Software Kinetics Ltd. has granted a licence of this software to the
 * National Library of Canada.
 *
 * The National Library of Canada grants to the user a royalty-free
 * non-exclusive licence in perpetuity to use, modify, improve, reproduce
 * and sell the software.
 *
 * The software is provided to the user "as is" without warranty of any
 * kind. Neither Software Kinetics Ltd. nor the National Library of Canada
 * warrants, guarantees or makes any representations regarding the use,
 * or the results of use of the software in terms of accuracy, reliability,
 * or otherwise. The entire risk as to results and performance of the
 * software is assumed by the user. Neither Software Kinetics Ltd. nor the
 * National Library of Canada shall be liable for any direct, indirect,
 * consequential or incidental damages arising out of the use of the
 * software.
 *
 ************************************************************************/
IR_STATUS UaRdc_DRDlgDeleteRemote(WINDOW, UAEP_DIALOG *);
IR_STATUS UaRdc_DRDlgFetchRemote(WINDOW, UAEP_DIALOG *);
IR_STATUS UaRdc_DRDlgDeleteLocal(WINDOW, UAEP_DIALOG *);
static void clearList();
static SLIST DisplayList = (SLIST)NULL;
static void clearList()
{
	if (DisplayList)
	{
		slist_dispose(DisplayList);
		DisplayList = (SLIST)NULL;
	}
}
/*
	Handler for dialog DLG_RESULT_DISPLAY ("Result Management")
*/
long
#if XVT_CC_PROTO
dlg_110_eh(WINDOW xdWindow, EVENT *xdEvent)
#else
dlg_110_eh(xdWindow, xdEvent)
WINDOW xdWindow;
EVENT *xdEvent;
#endif
{
	short xdControlId = xdEvent->v.ctl.id;
	UAEP_DIALOG	*info;
	switch (xdEvent->type) {
	case E_CREATE:
		/*
			Dialog has been created; first event sent to newly-created
			dialog.
		*/
		{
		if (DisplayList == (SLIST)NULL)
		{
			DisplayList = slist_new();
		}
		if (UaRdc_DRDlgInit(xdWindow, DisplayList) != IR_SUCCESS)
		{
			close_window(xdWindow);
		}
		}
		break;
	case E_DESTROY:
		/*
			Dialog has been closed; last event sent to dialog.
		*/
		{
		/* Clear list is a local static function. */
		clearList();
		UaRdc_DRDlgDestroy(xdWindow);
		}
		break;
	case E_FOCUS:
		{
		/*
			Dialog has lost or gained focus.
		*/
		if (xdEvent->v.active)  {
			/*
				Dialog has gained focus
			*/
		} else {
			/*
				Dialog has lost focus
			*/
		}
		}
		break;
	case E_SIZE:
		/*
			Size of dialog has been set or changed; sent when dialog is
			created or subsequently resized by move_window.
		*/
		{
		}
		break;
	case E_CLOSE:
		/*
			Request to close dialog; user operated "close" menu item on
			dialog system menu, or operated "close" control on dialog
			frame. Dialog not closed unless close_window is called.
		*/
		{
		close_window(xdWindow);
		}
		break;
	case E_CHAR:
		/*
			Character typed.
		*/
		{
		}
		break;
	case E_CONTROL:
		/*
			User operated control in dialog.
		*/
		info = (UAEP_DIALOG *)get_app_data(xdWindow);
		switch(xdControlId) {
		case RD_OK: /* "Display Local" */
			{
			info->cancelled = FALSE;
			UaRdc_DRDlgGetSelect(get_ctl_window(xdWindow, RD_GET_LIST), 
			    DisplayList, info);
			if (info->data.display.wsId != IR_UNKNOWN_ID_TYPE)
			{
				close_window(xdWindow);
			}
			else
			{
				xvt_beep();
			}
			}
			break;
		case RD_CANCEL: /* "OK" */
			{
			info->cancelled = TRUE;
			close_window(xdWindow);
			}
			break;
		case RD_GET_LIST: /* " " */
			{
			/*
				List box was operated.
			*/
			if (xdEvent->v.ctl.ci.v.lbox.dbl_click) {
				/*
					double click
				*/
			} else {
				/*
					single click
				*/
			}
			UaRdc_DRDlgHandleList(get_ctl_window(xdWindow, RD_GET_LIST),
			    DisplayList, info);
			}
			break;
		case RD_PB_DELETE_LOCAL: /* "Delete Local" */
			{
			WINDOW listWin;
			info->cancelled = FALSE;
			listWin = get_ctl_window(xdWindow, RD_GET_LIST);
			UaRdc_DRDlgGetSelect(listWin, DisplayList,  info);
			/* Check for a selected work space */
			if (info->data.display.wsId != IR_UNKNOWN_ID_TYPE)
			{
				UaRdc_DRDlgDeleteLocal(xdWindow, info);
				/* New code to allow multiple deletes */
				clearList();
				UaRdc_DRDlgDestroy(xdWindow);
				win_list_suspend(listWin);
				win_list_clear(listWin);
				DisplayList = slist_new();
				if (UaRdc_DRDlgInit(xdWindow, DisplayList) == IR_FAIL)
				{
					/* No more work spaces to display */
					info->cancelled = TRUE;
					close_window(xdWindow);
				}
				else
				{
					win_list_resume(listWin);
				}
			}
			else
			{
				xvt_beep();
			}
			}
			break;
		case RD_PB_FETCH_REMOTE: /* "Fetch Remote" */
			{
			info->cancelled = FALSE;
			UaRdc_DRDlgGetSelect(get_ctl_window(xdWindow, RD_GET_LIST), 
			    DisplayList, info);
			/* Check for a selected work space */
			if (info->data.display.wsId != IR_UNKNOWN_ID_TYPE)
			{
				UaRdc_DRDlgFetchRemote(xdWindow, info);
				/* Fetch was Sent */
				if (info->cancelled == TRUE)
				{
					close_window(xdWindow);
				}
			
			}
			else
			{
				xvt_beep();
			}
			}
			break;
		case RD_PB_DELETE_REMOTE: /* "Delete Remote" */
			{
			WINDOW listWin;
			info->cancelled = FALSE;
			listWin = get_ctl_window(xdWindow, RD_GET_LIST);
			UaRdc_DRDlgGetSelect(get_ctl_window(xdWindow, RD_GET_LIST), 
			    DisplayList, info);
			/* Check for a selected work space */
			if (info->data.display.wsId != IR_UNKNOWN_ID_TYPE)
			{
				/* Check for a selected work space Not required for this one */
				UaRdc_DRDlgDeleteRemote(xdWindow, info) ;
				/* New code to allow multiple deletes */
				clearList();
				UaRdc_DRDlgDestroy(xdWindow);
				win_list_suspend(listWin);
				win_list_clear(listWin);
				DisplayList = slist_new();
				if (UaRdc_DRDlgInit(xdWindow, DisplayList) == IR_FAIL)
				{
					/* No more work spaces to display */
					info->cancelled = TRUE;
					close_window(xdWindow);
				}
				else
				{
					win_list_resume(listWin);
				}
			}
			else
			{
				xvt_beep();
			}
			}
			break;
		default:
			xvt_error("Unrecognized control in \"DLG_RESULT_DISPLAY\"");
			break;
		}
		break;
	case E_TIMER:
		/*
			Timer associated with window went off.
		*/
		{
		}
		break;
	case E_USER:
		/*
			Application initiated.
		*/
		{
		switch (xdEvent->v.user.id) {
		case -1:
		default:
			xvt_note("unknown user event");
			break;
		}
		}
		break;
	default:
		break;
	}
	return 0L;
}
